diff --git a/src/main/tls_listen.c b/src/main/tls_listen.c
index 66040e6980..c3c40d17ea 100644
--- a/src/main/tls_listen.c
+++ b/src/main/tls_listen.c
@@ -118,216 +118,9 @@ static int CC_HINT(nonnull) tls_socket_write(rad_listen_t *listener, REQUEST *re
 
 	return 1;
 }
-
-/*
- *	Check for PROXY protocol.  Once that's done, clear
- *	listener->proxy_protocol.
- */
-static int proxy_protocol_check(rad_listen_t *listener, REQUEST *request)
-{
-	listen_socket_t *sock = listener->data;
-	uint8_t const *p, *end, *eol;
-	int af, argc, src_port, dst_port;
-	unsigned long num;
-	fr_ipaddr_t src, dst;
-	char *argv[5], *eos;
-	ssize_t rcode;
-	RADCLIENT *client;
-
-	/*
-	 *	Begin by trying to fill the buffer.
-	 */
-	rcode = read(request->packet->sockfd,
-		     sock->ssn->dirty_in.data + sock->ssn->dirty_in.used,
-		     sizeof(sock->ssn->dirty_in.data) - sock->ssn->dirty_in.used);
-	if (rcode < 0) {
-		if (errno == EINTR) return 0;
-		RDEBUG("(TLS) Closing PROXY socket from client port %u due to read error - %s", sock->other_port, fr_syserror(errno));
-		return -1;
-	}
-
-	if (rcode == 0) {
-		DEBUG("(TLS) Closing PROXY socket from client port %u - other end closed connection", sock->other_port);
-		return -1;
-	}
-
-	/*
-	 *	We've read data, scan the buffer for a CRLF.
-	 */
-	sock->ssn->dirty_in.used += rcode;
-
-	dump_hex("READ FROM PROXY PROTOCOL SOCKET", sock->ssn->dirty_in.data, sock->ssn->dirty_in.used);
-
-	p = sock->ssn->dirty_in.data;
-
-	/*
-	 *	CRLF MUST be within the first 107 bytes.
-	 */
-	if (sock->ssn->dirty_in.used < 107) {
-		end = p + sock->ssn->dirty_in.used;
-	} else {
-		end = p + 107;
-	}
-	eol = NULL;
-
-	/*
-	 *	Scan for CRLF.
-	 */
-	while ((p + 1) < end) {
-		if ((p[0] == 0x0d) && (p[1] == 0x0a)) {
-			eol = p;
-			break;
-		}
-
-		/*
-		 *	Other control characters, or non-ASCII data.
-		 *	That's a problem.
-		 */
-		if ((*p < ' ') || (*p >= 0x80)) {
-		invalid_data:
-			DEBUG("(TLS) Closing PROXY socket from client port %u - received invalid data", sock->other_port);
-			return -1;
-		}
-
-		p++;
-	}
-
-	/*
-	 *	No CRLF, keep reading until we have it.
-	 */
-	if (!eol) return 0;
-
-	p = sock->ssn->dirty_in.data;
-
-	/*
-	 *	Let's see if the PROXY line is well-formed.
-	 */
-	if ((eol - p) < 14) goto invalid_data;
-	
-	/*
-	 *	We only support TCP4 and TCP6.
-	 */
-	if (memcmp(p, "PROXY TCP", 9) != 0) goto invalid_data;
-
-	p += 9;
-
-	if (*p == '4') {
-		af = AF_INET;
-
-	} else if (*p == '6') {
-		af = AF_INET6;
-
-	} else goto invalid_data;
-
-	p++;
-	if (*p != ' ') goto invalid_data;
-	p++;
-
-	sock->ssn->dirty_in.data[eol - sock->ssn->dirty_in.data] = '\0'; /* overwite the CRLF */
-
-	/*
-	 *	Parse the fields (being a little forgiving), while
-	 *	checking for too many / too few fields.
-	 */
-	argc = str2argv((char *) &sock->ssn->dirty_in.data[p - sock->ssn->dirty_in.data], (char **) &argv, 5);
-	if (argc != 4) goto invalid_data;
-
-	memset(&src, 0, sizeof(src));
-	memset(&dst, 0, sizeof(dst));
-
-	if (fr_pton(&src, argv[0], -1, af, false) < 0) goto invalid_data;
-	if (fr_pton(&dst, argv[1], -1, af, false) < 0) goto invalid_data;
-
-	num = strtoul(argv[2], &eos, 10);
-	if (num > 65535) goto invalid_data;
-	if (*eos) goto invalid_data;
-	src_port = num;
-
-	num = strtoul(argv[3], &eos, 10);
-	if (num > 65535) goto invalid_data;
-	if (*eos) goto invalid_data;
-	dst_port = num;
-
-	/*
-	 *	And copy the various fields around.
-	 */
-	sock->haproxy_src_ipaddr = sock->other_ipaddr;
-	sock->haproxy_src_port = sock->other_port;
-
-	sock->haproxy_dst_ipaddr = sock->my_ipaddr;
-	sock->haproxy_dst_port = sock->my_port;
-
-	sock->my_ipaddr = dst;
-	sock->my_port = dst_port;
-
-	sock->other_ipaddr = src;
-	sock->other_port = src_port;
-
-	/*
-	 *	Print out what we've changed.  Note that the TCP
-	 *	socket address family and the PROXY address family may
-	 *	be different!
-	 */
-	if (RDEBUG_ENABLED) {
-		char src_buf[128], dst_buf[128];
-
-		RDEBUG("(TLS) Received PROXY protocol connection from client %s:%s -> %s:%s, via proxy %s:%u -> %s:%u",
-		       argv[0], argv[2], argv[1], argv[3],
-		       inet_ntop(af, &sock->haproxy_src_ipaddr.ipaddr, src_buf, sizeof(src_buf)),
-		       sock->haproxy_src_port,
-		       inet_ntop(af, &sock->haproxy_dst_ipaddr.ipaddr, dst_buf, sizeof(dst_buf)),
-		       sock->haproxy_dst_port);
-	}
-
-        /*
-         *      Ensure that the source IP indicated by the PROXY
-         *      protocol is a known TLS client.
-         */
-        if ((client = client_listener_find(listener, &src, src_port)) == NULL ||
-             client->proto != IPPROTO_TCP) {
-		RDEBUG("(TLS) Unknown client %s - dropping PROXY protocol connection", argv[0]);
-		return -1;
-        }
-
-        /*
-         *      Use the client indicated by the proxy.
-         */
-        sock->client = client;
-
-	/*
-         *      Fix up the current request so that the first packet's
-         *      src/dst is valid.  Subsequent packets will get the
-         *      clients IP from the listener and listen_sock
-         *      structures.
-         */
-        request->packet->dst_ipaddr = dst;
-        request->packet->dst_port = dst_port;
-        request->packet->src_ipaddr = src;
-        request->packet->src_port = src_port;
-
-	/*
-	 *	Move any remaining TLS data to the start of the buffer.
-	 */
-	eol += 2;
-	end = sock->ssn->dirty_in.data + sock->ssn->dirty_in.used;
-	if (eol < end) {
-		memmove(sock->ssn->dirty_in.data, eol, end - eol);
-		sock->ssn->dirty_in.used = end - eol;
-	} else {
-		sock->ssn->dirty_in.used = 0;
-	}
-		
-	/*
-	 *	It's no longer a PROXY protocol, but just straight TLS.
-	 */
-	listener->proxy_protocol = false;
-
-	return 1;
-}
-
 static int tls_socket_recv(rad_listen_t *listener)
 {
-	bool doing_init = false, already_read = false;
+	bool doing_init = false;
 	ssize_t rcode;
 	RADIUS_PACKET *packet;
 	REQUEST *request;
@@ -392,30 +185,6 @@ static int tls_socket_recv(rad_listen_t *listener)
 
 	request = sock->request;
 
-	/*
-	 *	Bypass ALL of the TLS stuff until we've read the PROXY
-	 *	header.
-	 *
-	 *	If the PROXY header checks pass, then the flag is
-	 *	cleared, as we don't need it any more.
-	 */
-	if (listener->proxy_protocol) {
-		rcode = proxy_protocol_check(listener, request);
-		if (rcode < 0) {
-			RDEBUG("(TLS) Closing PROXY TLS socket from client port %u", sock->other_port);
-			tls_socket_close(listener);
-			return 0;
-		}
-		if (rcode == 0) return 1;
-
-		/*
-		 *	The buffer might already have data.  In that
-		 *	case, we don't want to do a blocking read
-		 *	later.
-		 */
-		already_read = (sock->ssn->dirty_in.used > 0);
-	}
-
 	if (sock->state == LISTEN_TLS_SETUP) {
 		RDEBUG3("(TLS) Setting connection state to RUNNING");
 		sock->state = LISTEN_TLS_RUNNING;
@@ -441,31 +210,28 @@ static int tls_socket_recv(rad_listen_t *listener)
 		goto check_for_setup;
 	}
 
-	if (!already_read) {
-		rcode = read(request->packet->sockfd,
-			     sock->ssn->dirty_in.data,
-			     sizeof(sock->ssn->dirty_in.data));
-		if ((rcode < 0) && (errno == ECONNRESET)) {
-		do_close:
-			DEBUG("(TLS) Closing socket from client port %u", sock->other_port);
-			tls_socket_close(listener);
-			PTHREAD_MUTEX_UNLOCK(&sock->mutex);
-			return 0;
-		}
-
-		if (rcode < 0) {
-			RDEBUG("(TLS) Error reading socket: %s", fr_syserror(errno));
-			goto do_close;
-		}
-
-		/*
-		 *	Normal socket close.
-		 */
-		if (rcode == 0) goto do_close;
+	rcode = read(request->packet->sockfd,
+		     sock->ssn->dirty_in.data,
+		     sizeof(sock->ssn->dirty_in.data));
+	if ((rcode < 0) && (errno == ECONNRESET)) {
+	do_close:
+		DEBUG("(TLS) Closing socket from client port %u", sock->other_port);
+		tls_socket_close(listener);
+		PTHREAD_MUTEX_UNLOCK(&sock->mutex);
+		return 0;
+	}
 
-		sock->ssn->dirty_in.used = rcode;
+	if (rcode < 0) {
+		RDEBUG("(TLS) Error reading socket: %s", fr_syserror(errno));
+		goto do_close;
 	}
 
+	/*
+	 *	Normal socket close.
+	 */
+	if (rcode == 0) goto do_close;
+
+	sock->ssn->dirty_in.used = rcode;
 	dump_hex("READ FROM SSL", sock->ssn->dirty_in.data, sock->ssn->dirty_in.used);
 
 	/*
@@ -496,8 +262,14 @@ check_for_setup:
 		}
 
 		/*
-		 *	Else we MUST be finished the SSL setup.
+		 *      If SSL handshake still isn't finished, then there
+		 *      is more data to read.  Release the mutex and
+		 *      return so this function will be called again
 		 */
+		if (!SSL_is_init_finished(sock->ssn->ssl)) {
+			PTHREAD_MUTEX_UNLOCK(&sock->mutex);
+			return 0;
+		}
 	}
 
 	/*
@@ -639,9 +411,6 @@ int dual_tls_recv(rad_listen_t *listener)
 	listen_socket_t *sock = listener->data;
 	RADCLIENT	*client = sock->client;
 	BIO		*rbio;
-#ifdef WITH_COA_TUNNEL
-	bool		is_reply = false;
-#endif
 
 	if (listener->status != RAD_LISTEN_STATUS_KNOWN) return 0;
 
@@ -700,14 +469,6 @@ redo:
 		FR_STATS_INC(dsc, total_requests);
 		fun = rad_coa_recv;
 		break;
-
-#ifdef WITH_COA_TUNNEL
-	case PW_CODE_COA_ACK:
-	case PW_CODE_COA_NAK:
-		if (!listener->send_coa) goto bad_packet;
-		is_reply = true;
-                break;
-#endif
 #endif
 
 	case PW_CODE_STATUS_SERVER:
@@ -734,15 +495,6 @@ redo:
 		return 0;
 	} /* switch over packet types */
 
-#ifdef WITH_COA_TUNNEL
-	if (is_reply) {
-		if (!request_proxy_reply(packet)) {
-			rad_free(&packet);
-			return 0;
-		}
-	} else
-#endif
-
 	if (!request_receive(NULL, listener, packet, client, fun)) {
 		FR_STATS_INC(auth, total_packets_dropped);
 		rad_free(&packet);
@@ -823,21 +575,6 @@ int dual_tls_send(rad_listen_t *listener, REQUEST *request)
 	 */
 	if (request->reply->code == 0) return 0;
 
-#ifdef WITH_COA_TUNNEL
-	/*
-	 *	Save the key, if we haven't already done that.
-	 */
-	if (listener->send_coa && !listener->key) {
-		VALUE_PAIR *vp = NULL;
-
-		vp = fr_pair_find_by_num(request->config, PW_ORIGINATING_REALM_KEY, 0, TAG_ANY);
-		if (vp) {
-			RDEBUG("Adding send CoA listener with key %s", vp->vp_strvalue);
-			listen_coa_add(request->listener, vp->vp_strvalue);
-		}
-	}
-#endif
-
 	/*
 	 *	Pack the VPs
 	 */
@@ -889,58 +626,6 @@ int dual_tls_send(rad_listen_t *listener, REQUEST *request)
 	return 0;
 }
 
-#ifdef WITH_COA_TUNNEL
-/*
- *	Send a CoA request to a NAS, as a proxied packet.
- *
- *	The proxied packet MUST already have been encoded.
- */
-int dual_tls_send_coa_request(rad_listen_t *listener, REQUEST *request)
-{
-	listen_socket_t *sock = listener->data;
-
-	VERIFY_REQUEST(request);
-
-	rad_assert(listener->proxy_send == dual_tls_send_coa_request);
-
-	if (listener->status != RAD_LISTEN_STATUS_KNOWN) return 0;
-
-	rad_assert(request->proxy->data);
-
-	if (request->proxy->data_len > (MAX_PACKET_LEN - 100)) {
-		RWARN("Packet is large, and possibly truncated - %zd vs max %d",
-		      request->proxy->data_len, MAX_PACKET_LEN);
-	}
-
-	PTHREAD_MUTEX_LOCK(&sock->mutex);
-
-	/*
-	 *	Write the packet to the SSL buffers.
-	 */
-	sock->ssn->record_plus(&sock->ssn->clean_in,
-			       request->proxy->data, request->proxy->data_len);
-
-	dump_hex("TUNNELED DATA < ", sock->ssn->clean_in.data, sock->ssn->clean_in.used);
-
-	/*
-	 *	Do SSL magic to get encrypted data.
-	 */
-	tls_handshake_send(request, sock->ssn);
-
-	/*
-	 *	And finally write the data to the socket.
-	 */
-	if (sock->ssn->dirty_out.used > 0) {
-		dump_hex("WRITE TO SSL", sock->ssn->dirty_out.data, sock->ssn->dirty_out.used);
-
-		tls_socket_write(listener, request);
-	}
-	PTHREAD_MUTEX_UNLOCK(&sock->mutex);
-
-	return 0;
-}
-#endif
-
 static int try_connect(tls_session_t *ssn)
 {
 	int ret;
@@ -1107,10 +792,6 @@ int proxy_tls_recv(rad_listen_t *listener)
 	RADIUS_PACKET *packet;
 	uint8_t *data;
 	ssize_t data_len;
-#ifdef WITH_COA_TUNNEL
-	bool is_request = false;
-	RADCLIENT *client = sock->client;
-#endif
 
 	if (listener->status != RAD_LISTEN_STATUS_KNOWN) return 0;
 
@@ -1165,25 +846,9 @@ int proxy_tls_recv(rad_listen_t *listener)
 	case PW_CODE_DISCONNECT_NAK:
 		break;
 
-#ifdef WITH_COA_TUNNEL
-	case PW_CODE_COA_REQUEST:
-		if (!listener->send_coa) goto bad_packet;
-		FR_STATS_INC(coa, total_requests);
-		is_request = true;
-		break;
-
-	case PW_CODE_DISCONNECT_REQUEST:
-		if (!listener->send_coa) goto bad_packet;
-		FR_STATS_INC(dsc, total_requests);
-		is_request = true;
-		break;
-#endif
 #endif
 
 	default:
-#ifdef WITH_COA_TUNNEL
-	bad_packet:
-#endif
 		/*
 		 *	FIXME: Update MIB for packet types?
 		 */
@@ -1196,15 +861,6 @@ int proxy_tls_recv(rad_listen_t *listener)
 		return 0;
 	}
 
-#ifdef WITH_COA_TUNNEL
-	if (is_request) {
-		if (!request_receive(NULL, listener, packet, client, rad_coa_recv)) {
-			FR_STATS_INC(auth, total_packets_dropped);
-			rad_free(&packet);
-			return 0;
-		}
-	} else
-#endif
 	if (!request_proxy_reply(packet)) {
 		rad_free(&packet);
 		return 0;
@@ -1275,71 +931,6 @@ int proxy_tls_send(rad_listen_t *listener, REQUEST *request)
 
 	return 1;
 }
-
-#ifdef WITH_COA_TUNNEL
-int proxy_tls_send_reply(rad_listen_t *listener, REQUEST *request)
-{
-	int rcode;
-	listen_socket_t *sock = listener->data;
-
-	VERIFY_REQUEST(request);
-
-	rad_assert(sock->ssn->connected);
-
-	if ((listener->status != RAD_LISTEN_STATUS_INIT &&
-	    (listener->status != RAD_LISTEN_STATUS_KNOWN))) return 0;
-
-	/*
-	 *	Pack the VPs
-	 */
-	if (rad_encode(request->reply, request->packet,
-		       request->client->secret) < 0) {
-		RERROR("Failed encoding packet: %s", fr_strerror());
-		return 0;
-	}
-
-	if (request->reply->data_len > (MAX_PACKET_LEN - 100)) {
-		RWARN("Packet is large, and possibly truncated - %zd vs max %d",
-		      request->reply->data_len, MAX_PACKET_LEN);
-	}
-
-	/*
-	 *	Sign the packet.
-	 */
-	if (rad_sign(request->reply, request->packet,
-		       request->client->secret) < 0) {
-		RERROR("Failed signing packet: %s", fr_strerror());
-		return 0;
-	}
-
-	DEBUG3("Proxy is writing %u bytes to SSL",
-	       (unsigned int) request->reply->data_len);
-	PTHREAD_MUTEX_LOCK(&sock->mutex);
-	rcode = SSL_write(sock->ssn->ssl, request->reply->data,
-			  request->reply->data_len);
-	if (rcode < 0) {
-		int err;
-
-		err = ERR_get_error();
-		switch (err) {
-		case SSL_ERROR_NONE:
-		case SSL_ERROR_WANT_READ:
-		case SSL_ERROR_WANT_WRITE:
-			break;	/* let someone else retry */
-
-		default:
-			tls_error_log(NULL, "Failed in proxy send");
-			DEBUG("Closing TLS socket to home server");
-			tls_socket_close(listener);
-			PTHREAD_MUTEX_UNLOCK(&sock->mutex);
-			return 0;
-		}
-	}
-	PTHREAD_MUTEX_UNLOCK(&sock->mutex);
-
-	return 1;
-}
-#endif	/* WITH_COA_TUNNEL */
 #endif	/* WITH_PROXY */
 
 #endif	/* WITH_TLS */
diff --git a/src/main/version.c b/src/main/version.c
index 728be50a93..f1f1e87810 100644
--- a/src/main/version.c
+++ b/src/main/version.c
@@ -348,14 +348,6 @@ void version_init_features(CONF_SECTION *cs)
 				);
 
 
-	version_add_feature(cs, "recv-coa-from-home-server",
-#ifdef WITH_COA_TUNNEL
-			        true
-#else
-				false
-#endif
-				);
-
 	version_add_feature(cs, "control-socket",
 #ifdef WITH_COMMAND_SOCKET
 				true
diff --git a/src/main/xlat.c b/src/main/xlat.c
index 998751f9db..583686a7db 100644
--- a/src/main/xlat.c
+++ b/src/main/xlat.c
@@ -87,6 +87,50 @@ static char const * const xlat_foreach_names[] = {"Foreach-Variable-0",
 
 static int xlat_inst[] = { 0, 1, 2, 3, 4, 5, 6, 7, 8, 9 };	/* up to 10 for foreach */
 
+static char *xlat_getvp(TALLOC_CTX *ctx, REQUEST *request, vp_tmpl_t const *vpt,
+			bool escape, bool return_null, char const *concat);
+
+/** Concatenation
+ *
+ */
+static ssize_t xlat_concat(UNUSED void *instance, REQUEST *request,
+			   char const *fmt, char *out, size_t outlen)
+{
+	ssize_t slen;
+	vp_tmpl_t vpt;
+	char *str;
+	char const *concat;
+	char buffer[2];
+
+	while (isspace((int) *fmt)) fmt++;
+
+	slen = tmpl_from_attr_substr(&vpt, fmt,  REQUEST_CURRENT, PAIR_LIST_REQUEST, false, false);
+	if (slen <= 0) {
+		RDEBUG("%s", fr_strerror());
+		return -1;
+	}
+
+	fmt += slen;
+	while (isspace((int) *fmt)) fmt++;
+
+	if (!*fmt) {
+		concat = ",";
+	} else {
+		buffer[0] = *fmt;
+		buffer[1] = '\0';
+
+		concat = buffer;
+	}
+
+	str = xlat_getvp(request, request, &vpt, true, true, concat);
+	if (!str) return 0;
+
+	strlcpy(out, str, outlen);
+	talloc_free(str);
+
+	return strlen(out);
+}
+
 /** Print length of its RHS.
  *
  */
@@ -775,6 +819,7 @@ int xlat_register(char const *name, xlat_func_t func, xlat_escape_t escape, void
 		rad_assert(c != NULL); \
 		c->internal = true
 
+		XLAT_REGISTER(concat);
 		XLAT_REGISTER(integer);
 		XLAT_REGISTER(strlen);
 		XLAT_REGISTER(length);
@@ -1804,7 +1849,7 @@ static ssize_t xlat_tokenize_request(REQUEST *request, char const *fmt, xlat_exp
 
 
 static char *xlat_getvp(TALLOC_CTX *ctx, REQUEST *request, vp_tmpl_t const *vpt,
-			bool escape, bool return_null)
+			bool escape, bool return_null, char const *concat)
 {
 	VALUE_PAIR *vp = NULL, *virtual = NULL;
 	RADIUS_PACKET *packet = NULL;
@@ -2050,7 +2095,7 @@ do_print:
 		while ((vp = tmpl_cursor_next(&cursor, vpt)) != NULL) {
 			q = vp_aprints_value(ctx, vp, quote);
 			if (!q) return NULL;
-			p = talloc_strdup_append(p, ",");
+			p = talloc_strdup_append(p, concat);
 			p = talloc_strdup_append(p, q);
 		}
 
@@ -2243,7 +2288,7 @@ static char *xlat_aprint(TALLOC_CTX *ctx, REQUEST *request, xlat_exp_t const * c
 		/*
 		 *	Some attributes are virtual <sigh>
 		 */
-		str = xlat_getvp(ctx, request, &node->attr, escape ? false : true, true);
+		str = xlat_getvp(ctx, request, &node->attr, escape ? false : true, true, ",");
 		if (str) {
 			XLAT_DEBUG("%.*sEXPAND attr %s", lvl, xlat_spaces, node->attr.tmpl_da->name);
 			XLAT_DEBUG("%.*s       ---> %s", lvl ,xlat_spaces, str);
diff --git a/src/modules/rlm_eap/libeap/eap_tls.c b/src/modules/rlm_eap/libeap/eap_tls.c
index 17e4cadca8..2f37663df1 100644
--- a/src/modules/rlm_eap/libeap/eap_tls.c
+++ b/src/modules/rlm_eap/libeap/eap_tls.c
@@ -1,3 +1,4 @@
+
 /*
  * eap_tls.c
  *
@@ -167,7 +168,7 @@ int eaptls_success(eap_handler_t *handler, int peap_flag)
 		uint8_t const context_tls13[] = { handler->type };
 #endif
 
-		switch (tls_session->info.version) {
+		switch (SSL_version(tls_session->ssl)) {
 #ifdef TLS1_3_VERSION
 		case TLS1_3_VERSION:
 			context = context_tls13;
@@ -764,7 +765,7 @@ static fr_tls_status_t eaptls_operation(fr_tls_status_t status, eap_handler_t *h
 	 *	data to be sent. So this is done always for EAP-TLS but
 	 *	notibly not for PEAP even on resumption.
 	 */
-	if ((tls_session->info.version == TLS1_3_VERSION) &&
+	if ((SSL_version(tls_session->ssl) == TLS1_3_VERSION) &&
 	    (tls_session->client_cert_ok || tls_session->authentication_success || SSL_session_reused(tls_session->ssl))) {
 		if ((handler->type == PW_EAP_TLS) || SSL_session_reused(tls_session->ssl)) {
 			tls_session->authentication_success = true;
@@ -794,6 +795,20 @@ static fr_tls_status_t eaptls_operation(fr_tls_status_t status, eap_handler_t *h
 	 */
 	if (tls_session->is_init_finished) return FR_TLS_SUCCESS;
 
+	/*
+	 *	If session is established, skip round-trip and
+	 *	try to process any inner tunnel data if present.
+	 *
+	 *	This occurs for EAP-TTLS/PAP with TLSv1.3.
+	 */
+	if (!tls_session->is_init_finished && SSL_is_init_finished(tls_session->ssl)) {
+		/*
+		 *	Don't set is_init_finished, as that causes the
+		 *	rest of the code to make too many assumptions.
+		 */
+		return FR_TLS_OK;
+	}
+
 	/*
 	 *	Who knows what happened...
 	 */
diff --git a/src/modules/rlm_eap/libeap/eapsimlib.c b/src/modules/rlm_eap/libeap/eapsimlib.c
index cf1e8a7dd9..67e21b2a78 100644
--- a/src/modules/rlm_eap/libeap/eapsimlib.c
+++ b/src/modules/rlm_eap/libeap/eapsimlib.c
@@ -307,42 +307,77 @@ int unmap_eapsim_basictypes(RADIUS_PACKET *r,
 	newvp->vp_length = 1;
 	fr_pair_add(&(r->vps), newvp);
 
+	/*
+	 *	EAP-SIM has a 1 octet of subtype, and 2 octets
+	 *	reserved.
+	 */
 	attr     += 3;
 	attrlen  -= 3;
 
-	/* now, loop processing each attribute that we find */
-	while(attrlen > 0) {
+	/*
+	 *	Loop over each attribute.  The format is:
+	 *
+	 *	1 octet of type
+	 *	1 octet of length (value 1..255)
+	 *	((4 * length) - 2) octets of data.
+	 */
+	while (attrlen > 0) {
 		uint8_t *p;
 
-		if(attrlen < 2) {
+		if (attrlen < 2) {
 			fr_strerror_printf("EAP-Sim attribute %d too short: %d < 2", es_attribute_count, attrlen);
 			return 0;
 		}
 
+		if (!attr[1]) {
+			fr_strerror_printf("EAP-Sim attribute %d (no.%d) has no data", attr[0],
+					   es_attribute_count);
+			return 0;
+		}
+
 		eapsim_attribute = attr[0];
 		eapsim_len = attr[1] * 4;
 
+		/*
+		 *	The length includes the 2-byte header.
+		 */
 		if (eapsim_len > attrlen) {
 			fr_strerror_printf("EAP-Sim attribute %d (no.%d) has length longer than data (%d > %d)",
 					   eapsim_attribute, es_attribute_count, eapsim_len, attrlen);
 			return 0;
 		}
 
-		if(eapsim_len > MAX_STRING_LEN) {
-			eapsim_len = MAX_STRING_LEN;
-		}
-		if (eapsim_len < 2) {
-			fr_strerror_printf("EAP-Sim attribute %d (no.%d) has length too small", eapsim_attribute,
-					   es_attribute_count);
-			return 0;
-		}
+		newvp = fr_pair_afrom_num(r, eapsim_attribute + PW_EAP_SIM_BASE, 0);
+		if (!newvp) {
+			/*
+			 *	RFC 4186 Section 8.1 says 0..127 are
+			 *	"non-skippable".  If one such
+			 *	attribute is found and we don't
+			 *	understand it, the server has to send:
+			 *
+			 *	EAP-Request/SIM/Notification packet with an
+			 *	(AT_NOTIFICATION code, which implies general failure ("General
+			 *	failure after authentication" (0), or "General failure" (16384),
+			 *	depending on the phase of the exchange), which terminates the
+			 *	authentication exchange.
+			 */
+			if (eapsim_attribute <= 127) {
+				fr_strerror_printf("Unknown mandatory attribute %d, failing",
+						   eapsim_attribute);
+				return 0;
+			}
 
-		newvp = fr_pair_afrom_num(r, eapsim_attribute+PW_EAP_SIM_BASE, 0);
-		newvp->vp_length = eapsim_len-2;
-		newvp->vp_octets = p = talloc_array(newvp, uint8_t, newvp->vp_length);
-		memcpy(p, &attr[2], eapsim_len-2);
-		fr_pair_add(&(r->vps), newvp);
-		newvp = NULL;
+		} else {
+			/*
+			 *	It's known, ccount for header, and
+			 *	copy the value over.
+			 */
+			newvp->vp_length = eapsim_len - 2;
+
+			newvp->vp_octets = p = talloc_array(newvp, uint8_t, newvp->vp_length);
+			memcpy(p, &attr[2], newvp->vp_length);
+			fr_pair_add(&(r->vps), newvp);
+		}
 
 		/* advance pointers, decrement length */
 		attr += eapsim_len;
diff --git a/src/modules/rlm_eap/libeap/mppe_keys.c b/src/modules/rlm_eap/libeap/mppe_keys.c
index 237c671d97..4f5b6a8e71 100644
--- a/src/modules/rlm_eap/libeap/mppe_keys.c
+++ b/src/modules/rlm_eap/libeap/mppe_keys.c
@@ -28,6 +28,7 @@ USES_APPLE_DEPRECATED_API	/* OpenSSL API has been deprecated by Apple */
 #include "eap_tls.h"
 #include <openssl/ssl.h>
 #include <openssl/hmac.h>
+#include <freeradius-devel/openssl3.h>
 
 /*
  *	TLS P_hash from RFC 2246/5246 section 5
@@ -39,7 +40,8 @@ static void P_hash(EVP_MD const *evp_md,
 {
 	HMAC_CTX *ctx_a, *ctx_out;
 	unsigned char a[EVP_MAX_MD_SIZE];
-	unsigned int size;
+	unsigned int size = EVP_MAX_MD_SIZE;
+	unsigned int digest_len;
 
 	ctx_a = HMAC_CTX_new();
 	ctx_out = HMAC_CTX_new();
@@ -50,11 +52,9 @@ static void P_hash(EVP_MD const *evp_md,
 	HMAC_Init_ex(ctx_a, secret, secret_len, evp_md, NULL);
 	HMAC_Init_ex(ctx_out, secret, secret_len, evp_md, NULL);
 
-	size = HMAC_size(ctx_out);
-
 	/* Calculate A(1) */
 	HMAC_Update(ctx_a, seed, seed_len);
-	HMAC_Final(ctx_a, a, NULL);
+	HMAC_Final(ctx_a, a, &size);
 
 	while (1) {
 		/* Calculate next part of output */
@@ -63,13 +63,15 @@ static void P_hash(EVP_MD const *evp_md,
 
 		/* Check if last part */
 		if (out_len < size) {
-			HMAC_Final(ctx_out, a, NULL);
+			digest_len = EVP_MAX_MD_SIZE;
+			HMAC_Final(ctx_out, a, &digest_len);
 			memcpy(out, a, out_len);
 			break;
 		}
 
 		/* Place digest in output buffer */
-		HMAC_Final(ctx_out, out, NULL);
+		digest_len = EVP_MAX_MD_SIZE;
+		HMAC_Final(ctx_out, out, &digest_len);
 		HMAC_Init_ex(ctx_out, NULL, 0, NULL, NULL);
 		out += size;
 		out_len -= size;
@@ -77,7 +79,8 @@ static void P_hash(EVP_MD const *evp_md,
 		/* Calculate next A(i) */
 		HMAC_Init_ex(ctx_a, NULL, 0, NULL, NULL);
 		HMAC_Update(ctx_a, a, size);
-		HMAC_Final(ctx_a, a, NULL);
+		digest_len = EVP_MAX_MD_SIZE;
+		HMAC_Final(ctx_a, a, &digest_len);
 	}
 
 	HMAC_CTX_free(ctx_a);
@@ -178,35 +181,6 @@ void eaptls_gen_mppe_keys(REQUEST *request, SSL *s, char const *label, uint8_t c
 		ERROR("Failed generating keying material");
 		return;
 	}
-
-	if (RDEBUG_ENABLED4) {
-		size_t i, client_len, master_len;
-		uint8_t client_random[SSL3_RANDOM_SIZE];
-		uint8_t master_key[SSL_MAX_MASTER_KEY_LENGTH];
-		char *q, buffer[64 + 2*SSL3_RANDOM_SIZE + 2*SSL_MAX_MASTER_KEY_LENGTH];
-
-		client_len = SSL_get_client_random(s, client_random, sizeof(client_random));
-		master_len = SSL_SESSION_get_master_key(SSL_get_session(s), master_key, sizeof(master_key));
-
-		strcpy(buffer, "CLIENT_RANDOM ");
-		q = buffer + 14;
-
-		for (i = 0; i < client_len; i++) {
-			sprintf(q, "%02X", client_random[i]);
-			q += 2;
-		}
-		*(q++) = ' ';
-
-		for (i = 0; i < master_len; i++) {
-			sprintf(q, "%02X", master_key[i]);
-			q += 2;
-		}
-		*q = '\0';
-
-		RDEBUG("(TLS) KEYLOG: %s", buffer);
-
-	}
-
 #else
 	{
 		uint8_t seed[64 + (2 * SSL3_RANDOM_SIZE) + (context ? 2 + context_size : 0)];
@@ -239,33 +213,6 @@ void eaptls_gen_mppe_keys(REQUEST *request, SSL *s, char const *label, uint8_t c
 		PRF(s->session->master_key, s->session->master_key_length,
 		    seed, len, out, buf, sizeof(out));
 	}
-
-	if (RDEBUG_ENABLED4) {
-		size_t i, master_len;
-		char *q, buffer[64 + 2*SSL3_RANDOM_SIZE + 2*SSL_MAX_MASTER_KEY_LENGTH];
-
-		client_len = SSL_get_client_random(s, client_random, sizeof(client_random));
-		master_len = s->session->master_key_length;
-		if (master_len > SSL_MAX_MASTER_KEY_LENGTH) master_len = SSL_MAX_MASTER_KEY_LENGTH;
-
-		strcpy(buffer, "CLIENT_RANDOM ");
-		q = buffer + 14;
-
-		for (i = 0; i < SSL3_RANDOM_SIZE; i++) {
-			sprintf(q, "%02X", s->s3->client_random[i]);
-			q += 2;
-		}
-		*(q++) = ' ';
-
-		for (i = 0; i < master_len; i++) {
-			sprintf(q, "%02X", s->session->master_key[i]);
-			q += 2;
-		}
-		*q = '\0';
-
-		RDEBUG("(TLS) KEYLOG: %s", buffer);
-
-	}
 #endif
 
 	p = out;
@@ -333,7 +280,7 @@ void eaptls_gen_eap_key(eap_handler_t *handler)
 
 	*p++ = type;
 
-	switch (tls_session->info.version) {
+	switch (SSL_version(tls_session->ssl)) {
 	case TLS1_VERSION:
 	case TLS1_1_VERSION:
 	case TLS1_2_VERSION:
diff --git a/src/modules/rlm_eap/types/rlm_eap_fast/eap_fast.c b/src/modules/rlm_eap/types/rlm_eap_fast/eap_fast.c
index 8c63498586..bbb5a03c95 100644
--- a/src/modules/rlm_eap/types/rlm_eap_fast/eap_fast.c
+++ b/src/modules/rlm_eap/types/rlm_eap_fast/eap_fast.c
@@ -128,7 +128,7 @@ static void eap_fast_init_keys(REQUEST *request, tls_session_t *tls_session)
 
 	t->keyblock = talloc(t, eap_fast_keyblock_t);
 
-	eap_fast_tls_gen_challenge(tls_session->ssl, tls_session->info.version, buf, ksize + sizeof(*t->keyblock), "key expansion");
+	eap_fast_tls_gen_challenge(tls_session->ssl, SSL_version(tls_session->ssl), buf, ksize + sizeof(*t->keyblock), "key expansion");
 	memcpy(t->keyblock, &buf[ksize], sizeof(*t->keyblock));
 	memset(buf, 0, ksize + sizeof(*t->keyblock));
 
diff --git a/src/modules/rlm_eap/types/rlm_eap_fast/eap_fast_crypto.h b/src/modules/rlm_eap/types/rlm_eap_fast/eap_fast_crypto.h
index c2f40dd7d5..d00e9a250b 100644
--- a/src/modules/rlm_eap/types/rlm_eap_fast/eap_fast_crypto.h
+++ b/src/modules/rlm_eap/types/rlm_eap_fast/eap_fast_crypto.h
@@ -1,3 +1,32 @@
+/*
+ * eap_fast_crypto.h
+ *
+ * Version:     $Id$
+ *
+ *   This program is free software; you can redistribute it and/or modify
+ *   it under the terms of the GNU General Public License as published by
+ *   the Free Software Foundation; either version 2 of the License, or
+ *   (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301, USA
+ *
+ * Copyright 2003 Alan DeKok <aland@freeradius.org>
+ * Copyright 2006 The FreeRADIUS server project
+ */
+
+#ifndef _EAP_FAST_CRYPTO_H
+#define _EAP_FAST_CRYPTO_H
+
+RCSIDH(eap_fast_crypto_h, "$Id$")
+
+
 int eap_fast_encrypt(uint8_t const *plaintext, size_t plaintext_len,
 		     uint8_t const *aad, size_t aad_len,
 		     uint8_t const *key, uint8_t *iv, unsigned char *ciphertext,
@@ -6,3 +35,5 @@ int eap_fast_encrypt(uint8_t const *plaintext, size_t plaintext_len,
 int eap_fast_decrypt(uint8_t const *ciphertext, size_t ciphertext_len,
 		     uint8_t const *aad, size_t aad_len,
 		     uint8_t const *tag, uint8_t const *key, uint8_t const *iv, uint8_t *plaintext);
+
+#endif /* _EAP_FAST_CRYPTO_H */
diff --git a/src/modules/rlm_eap/types/rlm_eap_fast/rlm_eap_fast.c b/src/modules/rlm_eap/types/rlm_eap_fast/rlm_eap_fast.c
index 7c91d34050..093dc868cd 100644
--- a/src/modules/rlm_eap/types/rlm_eap_fast/rlm_eap_fast.c
+++ b/src/modules/rlm_eap/types/rlm_eap_fast/rlm_eap_fast.c
@@ -575,7 +575,8 @@ static int mod_session_init(void *type_arg, eap_handler_t *handler)
 
 	/*
 	 *	Don't allow TLS 1.3 for us, even if it's allowed
-	 *	elsewhere.
+	 *	elsewhere.  We haven't implemented the necessary
+	 *	changes, so we don't allow it.
 	 */
 	handler->opaque = tls_session = eaptls_session(handler, inst->tls_conf, client_cert, false);
 
@@ -627,6 +628,7 @@ static int mod_session_init(void *type_arg, eap_handler_t *handler)
 	rcode = eap_fast_tls_start(handler->eap_ds, tls_session);
 
 	if (rcode < 0) {
+	error:
 		talloc_free(tls_session);
 		return 0;
 	}
@@ -635,7 +637,7 @@ static int mod_session_init(void *type_arg, eap_handler_t *handler)
 
 	if (!SSL_set_session_ticket_ext_cb(tls_session->ssl, _session_ticket, tls_session)) {
 		RERROR("Failed setting SSL session ticket callback");
-		return 0;
+		goto error;
 	}
 
 	handler->stage = PROCESS;
diff --git a/src/modules/rlm_eap/types/rlm_eap_peap/rlm_eap_peap.c b/src/modules/rlm_eap/types/rlm_eap_peap/rlm_eap_peap.c
index 4bbf57330f..d9f850cef2 100644
--- a/src/modules/rlm_eap/types/rlm_eap_peap/rlm_eap_peap.c
+++ b/src/modules/rlm_eap/types/rlm_eap_peap/rlm_eap_peap.c
@@ -135,25 +135,6 @@ static int mod_instantiate(CONF_SECTION *cs, void **instance)
 		inst->auth_type_eap = dv->value;
 	}
 
-#ifdef TLS1_3_VERSION
-	if ((inst->tls_conf->min_version == TLS1_3_VERSION) && !inst->tls_conf->tls13_enable_magic) {
-		ERROR("There are no standards for using TLS 1.3 with PEAP.");
-		ERROR("You MUST enable TLS 1.2 for PEAP to work.");
-		return -1;
-	}
-
-	if ((inst->tls_conf->max_version == TLS1_3_VERSION) ||
-	    (inst->tls_conf->min_version == TLS1_3_VERSION)) {
-		WARN("!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!");
-		WARN("!! There is no standard for using PEAP with TLS 1.3");
-		WARN("!! Please set tls_max_version = \"1.2\"");
-		WARN("!! FreeRADIUS only supports TLS 1.3 for special builds of wpa_supplicant and Windows");
-		WARN("!! This limitation is likely to change in late 2021.");
-		WARN("!! If you are using this version of FreeRADIUS after 2021, you will probably need to upgrade");
-		WARN("!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!");
-}
-#endif
-
 	return 0;
 }
 
@@ -212,10 +193,9 @@ static int mod_session_init(void *type_arg, eap_handler_t *handler)
 	}
 
 	/*
-	 *	Don't allow TLS 1.3 for us, even if it's allowed
-	 *	elsewhere.
+	 *	Allow TLS 1.3, it works.
 	 */
-	ssn = eaptls_session(handler, inst->tls_conf, client_cert, inst->tls_conf->tls13_enable_magic);
+	ssn = eaptls_session(handler, inst->tls_conf, client_cert, true);
 	if (!ssn) {
 		return 0;
 	}
